package ic2.api;

import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

public enum Direction
{
    XN, 
    XP, 
    YN, 
    YP, 
    ZN, 
    ZP;
    
    public static final Direction[] directions;
    
    public static Direction fromSideValue(final int side) {
        return Direction.directions[(side + 2) % 6];
    }
    
    public static Direction fromEnumFacing(final EnumFacing dir) {
        if (dir == null) {
            return null;
        }
        return fromSideValue(dir.func_176745_a());
    }
    
    public TileEntity applyToTileEntity(final TileEntity te) {
        return this.applyTo(te.func_145831_w(), te.func_174877_v());
    }
    
    public TileEntity applyTo(final World world, final BlockPos pos) {
        final int[] array;
        final int[] coords = array = new int[] { pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p() };
        final int n = this.ordinal() / 2;
        array[n] += this.getSign();
        BlockPos pos2 = new BlockPos(coords[0], coords[1], coords[2]);
        if (world != null && world.func_175667_e(pos2)) {
            try {
                return world.func_175625_s(pos2);
            }
            catch (Exception e) {
                throw new RuntimeException("error getting TileEntity at dim " + world.field_73011_w.getDimension() + " " + pos2.toString());
            }
        }
        return null;
    }
    
    public Direction getInverse() {
        return Direction.directions[this.ordinal() ^ 0x1];
    }
    
    public int toSideValue() {
        return (this.ordinal() + 4) % 6;
    }
    
    private int getSign() {
        return this.ordinal() % 2 * 2 - 1;
    }
    
    public EnumFacing toEnumFacing() {
        return EnumFacing.func_82600_a(this.toSideValue());
    }
    
    static {
        directions = values();
    }
}
