package ic2.api.energy.prefab;

import net.minecraft.util.ITickable;
import net.minecraft.tileentity.*;
import net.minecraft.util.EnumFacing;
import net.minecraftforge.fml.common.*;
import ic2.api.info.*;
import net.minecraftforge.common.*;
import ic2.api.energy.tile.*;
import net.minecraftforge.fml.common.eventhandler.*;
import ic2.api.energy.event.*;
import net.minecraft.nbt.*;
import net.minecraft.item.*;
import ic2.api.item.*;

public class BasicSink extends TileEntity implements IEnergySink, ITickable
{
    public final TileEntity parent;
    protected int capacity;
    protected int tier;
    protected double energyStored;
    protected boolean addedToEnet;
    
    public BasicSink(final TileEntity parent1, final int capacity1, final int tier1) {
        this.parent = parent1;
        this.capacity = capacity1;
        this.tier = tier1;
    }

    @Override
    public void func_73660_a() {
        if (!this.addedToEnet) {
            this.onLoaded();
        }
    }
    
    public void onLoaded() {
        if (!this.addedToEnet && !FMLCommonHandler.instance().getEffectiveSide().isClient() && Info.isIc2Available()) {
            this.field_145850_b = this.parent.func_145831_w();
            this.field_174879_c = this.parent.func_174877_v();
            MinecraftForge.EVENT_BUS.post(new EnergyTileLoadEvent(this));
            this.addedToEnet = true;
        }
    }
    
    public void func_145843_s() {
        super.func_145843_s();
        this.onChunkUnload();
    }
    
    public void onChunkUnload() {
        if (this.addedToEnet && Info.isIc2Available()) {
            MinecraftForge.EVENT_BUS.post((Event)new EnergyTileUnloadEvent(this));
            this.addedToEnet = false;
        }
    }
    
    public void func_145839_a(final NBTTagCompound tag) {
        super.func_145839_a(tag);
        final NBTTagCompound data = tag.func_74775_l("IC2BasicSink");
        this.energyStored = data.func_74769_h("energy");
    }
    
    public void func_145841_b(final NBTTagCompound tag) {
        try {
            super.func_145841_b(tag);
        }
        catch (RuntimeException ex) {}
        final NBTTagCompound data = new NBTTagCompound();
        data.func_74780_a("energy", this.energyStored);
        tag.func_74782_a("IC2BasicSink", (NBTBase)data);
    }
    
    public int getCapacity() {
        return this.capacity;
    }
    
    public void setCapacity(final int capacity1) {
        this.capacity = capacity1;
    }
    
    public int getTier() {
        return this.tier;
    }
    
    public void setTier(final int tier1) {
        this.tier = tier1;
    }
    
    public double getEnergyStored() {
        return this.energyStored;
    }
    
    public void setEnergyStored(final double amount) {
        this.energyStored = amount;
    }
    
    public boolean canUseEnergy(final double amount) {
        return this.energyStored >= amount;
    }
    
    public boolean useEnergy(final double amount) {
        if (this.canUseEnergy(amount) && !FMLCommonHandler.instance().getEffectiveSide().isClient()) {
            this.energyStored -= amount;
            return true;
        }
        return false;
    }
    
    public boolean discharge(final ItemStack stack, final int limit) {
        if (stack == null || !Info.isIc2Available()) {
            return false;
        }
        double amount = this.capacity - this.energyStored;
        if (amount <= 0.0) {
            return false;
        }
        if (limit > 0 && limit < amount) {
            amount = limit;
        }
        amount = ElectricItem.manager.discharge(stack, amount, this.tier, limit > 0, true, false);
        this.energyStored += amount;
        return amount > 0.0;
    }
    
    @Deprecated
    public void onUpdateEntity() {
        this.func_73660_a();
    }
    
    @Deprecated
    public void onInvalidate() {
        this.func_145843_s();
    }
    
    @Deprecated
    public void onOnChunkUnload() {
        this.onChunkUnload();
    }
    
    @Deprecated
    public void onReadFromNbt(final NBTTagCompound tag) {
        this.func_145839_a(tag);
    }
    
    @Deprecated
    public void onWriteToNbt(final NBTTagCompound tag) {
        this.func_145841_b(tag);
    }
    
    public boolean acceptsEnergyFrom(final TileEntity emitter, final EnumFacing direction) {
        return true;
    }
    
    public double getDemandedEnergy() {
        return Math.max(0.0, this.capacity - this.energyStored);
    }
    
    public double injectEnergy(final EnumFacing directionFrom, final double amount, final double voltage) {
        this.energyStored += amount;
        return 0.0;
    }
    
    public int getSinkTier() {
        return this.tier;
    }
}
